# coding: utf-8

"""
    NIUM Platform

    NIUM Platform

    Contact: experience@nium.com
    Do not edit the class manually.
"""  # noqa: E501


import re  # noqa: F401
import io
import warnings

from pydantic import validate_arguments, ValidationError

from typing_extensions import Annotated
from pydantic import Field, StrictFloat, StrictInt, StrictStr

from typing import Optional, Union

from nium.models.reference_rate_response_dto import ReferenceRateResponseDto

# from nium.api_client import ApiClient
import nium.api_client
from nium.api_response import ApiResponse
from nium.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class CardsReferenceDataApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = nium.api_client.ApiClient.get_default()
        self.api_client = api_client

    @validate_arguments
    def reference_exchange_rate(self, card_scheme : Annotated[StrictStr, Field(..., description="This field accepts the card scheme provider name: Visa Mastercard")], client_hash_id : Annotated[StrictStr, Field(..., description="Unique customer identifier generated on customer creation.")], from_amount : Annotated[Union[StrictFloat, StrictInt], Field(..., description="From Amount also known as transaction amount that will be converted from the fromCurrency and to the toCurrency.")], from_currency : Annotated[StrictStr, Field(..., description="This field contains the 3-letter [ISO-4217 currency code](doc:currency-and-country-codes) of the transaction currency.")], to_currency : Annotated[StrictStr, Field(..., description="This field contains the 3-letter [ISO-4217 currency code](doc:currency-and-country-codes) of the cardholder billing currency.")], x_request_id : Annotated[Optional[StrictStr], Field(description="Enter a unique UUID value.")] = None, **kwargs) -> ReferenceRateResponseDto:  # noqa: E501
        """Reference Exchange Rate  # noqa: E501

        This API allows you to get the reference exchange rate.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.reference_exchange_rate(card_scheme, client_hash_id, from_amount, from_currency, to_currency, x_request_id, async_req=True)
        >>> result = thread.get()

        :param card_scheme: This field accepts the card scheme provider name: Visa Mastercard (required)
        :type card_scheme: str
        :param client_hash_id: Unique customer identifier generated on customer creation. (required)
        :type client_hash_id: str
        :param from_amount: From Amount also known as transaction amount that will be converted from the fromCurrency and to the toCurrency. (required)
        :type from_amount: float
        :param from_currency: This field contains the 3-letter [ISO-4217 currency code](doc:currency-and-country-codes) of the transaction currency. (required)
        :type from_currency: str
        :param to_currency: This field contains the 3-letter [ISO-4217 currency code](doc:currency-and-country-codes) of the cardholder billing currency. (required)
        :type to_currency: str
        :param x_request_id: Enter a unique UUID value.
        :type x_request_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: ReferenceRateResponseDto
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the reference_exchange_rate_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.reference_exchange_rate_with_http_info(card_scheme, client_hash_id, from_amount, from_currency, to_currency, x_request_id, **kwargs)  # noqa: E501

    @validate_arguments
    def reference_exchange_rate_with_http_info(self, card_scheme : Annotated[StrictStr, Field(..., description="This field accepts the card scheme provider name: Visa Mastercard")], client_hash_id : Annotated[StrictStr, Field(..., description="Unique customer identifier generated on customer creation.")], from_amount : Annotated[Union[StrictFloat, StrictInt], Field(..., description="From Amount also known as transaction amount that will be converted from the fromCurrency and to the toCurrency.")], from_currency : Annotated[StrictStr, Field(..., description="This field contains the 3-letter [ISO-4217 currency code](doc:currency-and-country-codes) of the transaction currency.")], to_currency : Annotated[StrictStr, Field(..., description="This field contains the 3-letter [ISO-4217 currency code](doc:currency-and-country-codes) of the cardholder billing currency.")], x_request_id : Annotated[Optional[StrictStr], Field(description="Enter a unique UUID value.")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Reference Exchange Rate  # noqa: E501

        This API allows you to get the reference exchange rate.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.reference_exchange_rate_with_http_info(card_scheme, client_hash_id, from_amount, from_currency, to_currency, x_request_id, async_req=True)
        >>> result = thread.get()

        :param card_scheme: This field accepts the card scheme provider name: Visa Mastercard (required)
        :type card_scheme: str
        :param client_hash_id: Unique customer identifier generated on customer creation. (required)
        :type client_hash_id: str
        :param from_amount: From Amount also known as transaction amount that will be converted from the fromCurrency and to the toCurrency. (required)
        :type from_amount: float
        :param from_currency: This field contains the 3-letter [ISO-4217 currency code](doc:currency-and-country-codes) of the transaction currency. (required)
        :type from_currency: str
        :param to_currency: This field contains the 3-letter [ISO-4217 currency code](doc:currency-and-country-codes) of the cardholder billing currency. (required)
        :type to_currency: str
        :param x_request_id: Enter a unique UUID value.
        :type x_request_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(ReferenceRateResponseDto, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'card_scheme',
            'client_hash_id',
            'from_amount',
            'from_currency',
            'to_currency',
            'x_request_id'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method reference_exchange_rate" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['client_hash_id']:
            _path_params['clientHashId'] = _params['client_hash_id']


        # process the query parameters
        _query_params = []
        if _params.get('card_scheme') is not None:  # noqa: E501
            _query_params.append(('cardScheme', _params['card_scheme']))

        if _params.get('from_amount') is not None:  # noqa: E501
            _query_params.append(('fromAmount', _params['from_amount']))

        if _params.get('from_currency') is not None:  # noqa: E501
            _query_params.append(('fromCurrency', _params['from_currency']))

        if _params.get('to_currency') is not None:  # noqa: E501
            _query_params.append(('toCurrency', _params['to_currency']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['x_request_id']:
            _header_params['x-request-id'] = _params['x_request_id']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['default']  # noqa: E501

        _response_types_map = {
            '200': "ReferenceRateResponseDto",
            '401': None,
            '403': None,
            '404': None,
        }

        return self.api_client.call_api(
            '/api/v1/client/{clientHashId}/referenceRate', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
