# coding: utf-8

"""
    NIUM Platform

    NIUM Platform

    Contact: experience@nium.com
    Do not edit the class manually.
"""  # noqa: E501


import re  # noqa: F401
import io
import warnings

from pydantic import validate_arguments, ValidationError

from typing_extensions import Annotated
from pydantic import Field, StrictStr, constr

from typing import Optional

from nium.models.conversion_cancel_request import ConversionCancelRequest
from nium.models.conversion_cancel_response import ConversionCancelResponse
from nium.models.conversion_creation_request import ConversionCreationRequest
from nium.models.conversion_creation_response import ConversionCreationResponse

# from nium.api_client import ApiClient
import nium.api_client
from nium.api_response import ApiResponse
from nium.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class ConversionsApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = nium.api_client.ApiClient.get_default()
        self.api_client = api_client

    @validate_arguments
    def cancel_conversion(self, client_hash_id : Annotated[constr(strict=True, max_length=36, min_length=36), Field(..., description="Unique identifier of the client.")], customer_hash_id : Annotated[constr(strict=True, max_length=36, min_length=36), Field(..., description="Unique identifier of the customer.")], wallet_hash_id : Annotated[constr(strict=True, max_length=36, min_length=36), Field(..., description="Unique identifier of the wallet.")], conversion_id : StrictStr, conversion_cancel_request : Annotated[ConversionCancelRequest, Field(..., description="ConversionCancelRequest")], x_request_id : Annotated[Optional[StrictStr], Field(description="Enter a unique UUID value.")] = None, **kwargs) -> ConversionCancelResponse:  # noqa: E501
        """Cancel Conversion  # noqa: E501

        This API allows you to cancel a conversion prior to the execution time.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.cancel_conversion(client_hash_id, customer_hash_id, wallet_hash_id, conversion_id, conversion_cancel_request, x_request_id, async_req=True)
        >>> result = thread.get()

        :param client_hash_id: Unique identifier of the client. (required)
        :type client_hash_id: str
        :param customer_hash_id: Unique identifier of the customer. (required)
        :type customer_hash_id: str
        :param wallet_hash_id: Unique identifier of the wallet. (required)
        :type wallet_hash_id: str
        :param conversion_id: (required)
        :type conversion_id: str
        :param conversion_cancel_request: ConversionCancelRequest (required)
        :type conversion_cancel_request: ConversionCancelRequest
        :param x_request_id: Enter a unique UUID value.
        :type x_request_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: ConversionCancelResponse
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the cancel_conversion_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.cancel_conversion_with_http_info(client_hash_id, customer_hash_id, wallet_hash_id, conversion_id, conversion_cancel_request, x_request_id, **kwargs)  # noqa: E501

    @validate_arguments
    def cancel_conversion_with_http_info(self, client_hash_id : Annotated[constr(strict=True, max_length=36, min_length=36), Field(..., description="Unique identifier of the client.")], customer_hash_id : Annotated[constr(strict=True, max_length=36, min_length=36), Field(..., description="Unique identifier of the customer.")], wallet_hash_id : Annotated[constr(strict=True, max_length=36, min_length=36), Field(..., description="Unique identifier of the wallet.")], conversion_id : StrictStr, conversion_cancel_request : Annotated[ConversionCancelRequest, Field(..., description="ConversionCancelRequest")], x_request_id : Annotated[Optional[StrictStr], Field(description="Enter a unique UUID value.")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Cancel Conversion  # noqa: E501

        This API allows you to cancel a conversion prior to the execution time.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.cancel_conversion_with_http_info(client_hash_id, customer_hash_id, wallet_hash_id, conversion_id, conversion_cancel_request, x_request_id, async_req=True)
        >>> result = thread.get()

        :param client_hash_id: Unique identifier of the client. (required)
        :type client_hash_id: str
        :param customer_hash_id: Unique identifier of the customer. (required)
        :type customer_hash_id: str
        :param wallet_hash_id: Unique identifier of the wallet. (required)
        :type wallet_hash_id: str
        :param conversion_id: (required)
        :type conversion_id: str
        :param conversion_cancel_request: ConversionCancelRequest (required)
        :type conversion_cancel_request: ConversionCancelRequest
        :param x_request_id: Enter a unique UUID value.
        :type x_request_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(ConversionCancelResponse, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'client_hash_id',
            'customer_hash_id',
            'wallet_hash_id',
            'conversion_id',
            'conversion_cancel_request',
            'x_request_id'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method cancel_conversion" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['client_hash_id']:
            _path_params['clientHashId'] = _params['client_hash_id']

        if _params['customer_hash_id']:
            _path_params['customerHashId'] = _params['customer_hash_id']

        if _params['wallet_hash_id']:
            _path_params['walletHashId'] = _params['wallet_hash_id']

        if _params['conversion_id']:
            _path_params['conversionId'] = _params['conversion_id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['x_request_id']:
            _header_params['x-request-id'] = _params['x_request_id']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['conversion_cancel_request'] is not None:
            _body_params = _params['conversion_cancel_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['default']  # noqa: E501

        _response_types_map = {
            '200': "ConversionCancelResponse",
            '400': "CancelConversionErrorResponse",
            '401': "FXStandard401Error",
            '403': "FXStandard403Error",
            '404': "Standard404Error",
            '500': "FXStandard500Error",
        }

        return self.api_client.call_api(
            '/api/v1/client/{clientHashId}/customer/{customerHashId}/wallet/{walletHashId}/conversions/{conversionId}/cancel', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def create_conversion(self, client_hash_id : Annotated[constr(strict=True, max_length=36, min_length=36), Field(..., description="Unique identifier of the client.")], customer_hash_id : Annotated[constr(strict=True, max_length=36, min_length=36), Field(..., description="Unique identifier of the customer.")], wallet_hash_id : Annotated[constr(strict=True, max_length=36, min_length=36), Field(..., description="Unique identifier of the wallet.")], conversion_creation_request : Annotated[ConversionCreationRequest, Field(..., description="ConversionCreationRequest")], x_request_id : Annotated[Optional[StrictStr], Field(description="Enter a unique UUID value.")] = None, **kwargs) -> ConversionCreationResponse:  # noqa: E501
        """Create Conversion  # noqa: E501

        This API allows you to convert the balance from one currency to another within the same customer wallet either at the current market rate or using a previous exchange rate quote. This API allows you to select a settlement schedule for the conversion.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_conversion(client_hash_id, customer_hash_id, wallet_hash_id, conversion_creation_request, x_request_id, async_req=True)
        >>> result = thread.get()

        :param client_hash_id: Unique identifier of the client. (required)
        :type client_hash_id: str
        :param customer_hash_id: Unique identifier of the customer. (required)
        :type customer_hash_id: str
        :param wallet_hash_id: Unique identifier of the wallet. (required)
        :type wallet_hash_id: str
        :param conversion_creation_request: ConversionCreationRequest (required)
        :type conversion_creation_request: ConversionCreationRequest
        :param x_request_id: Enter a unique UUID value.
        :type x_request_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: ConversionCreationResponse
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the create_conversion_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.create_conversion_with_http_info(client_hash_id, customer_hash_id, wallet_hash_id, conversion_creation_request, x_request_id, **kwargs)  # noqa: E501

    @validate_arguments
    def create_conversion_with_http_info(self, client_hash_id : Annotated[constr(strict=True, max_length=36, min_length=36), Field(..., description="Unique identifier of the client.")], customer_hash_id : Annotated[constr(strict=True, max_length=36, min_length=36), Field(..., description="Unique identifier of the customer.")], wallet_hash_id : Annotated[constr(strict=True, max_length=36, min_length=36), Field(..., description="Unique identifier of the wallet.")], conversion_creation_request : Annotated[ConversionCreationRequest, Field(..., description="ConversionCreationRequest")], x_request_id : Annotated[Optional[StrictStr], Field(description="Enter a unique UUID value.")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Create Conversion  # noqa: E501

        This API allows you to convert the balance from one currency to another within the same customer wallet either at the current market rate or using a previous exchange rate quote. This API allows you to select a settlement schedule for the conversion.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_conversion_with_http_info(client_hash_id, customer_hash_id, wallet_hash_id, conversion_creation_request, x_request_id, async_req=True)
        >>> result = thread.get()

        :param client_hash_id: Unique identifier of the client. (required)
        :type client_hash_id: str
        :param customer_hash_id: Unique identifier of the customer. (required)
        :type customer_hash_id: str
        :param wallet_hash_id: Unique identifier of the wallet. (required)
        :type wallet_hash_id: str
        :param conversion_creation_request: ConversionCreationRequest (required)
        :type conversion_creation_request: ConversionCreationRequest
        :param x_request_id: Enter a unique UUID value.
        :type x_request_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(ConversionCreationResponse, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'client_hash_id',
            'customer_hash_id',
            'wallet_hash_id',
            'conversion_creation_request',
            'x_request_id'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_conversion" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['client_hash_id']:
            _path_params['clientHashId'] = _params['client_hash_id']

        if _params['customer_hash_id']:
            _path_params['customerHashId'] = _params['customer_hash_id']

        if _params['wallet_hash_id']:
            _path_params['walletHashId'] = _params['wallet_hash_id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['x_request_id']:
            _header_params['x-request-id'] = _params['x_request_id']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['conversion_creation_request'] is not None:
            _body_params = _params['conversion_creation_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['default']  # noqa: E501

        _response_types_map = {
            '200': "ConversionCreationResponse",
            '400': "CreateConversionErrorResponse",
            '401': "FXStandard401Error",
            '403': "FXStandard403Error",
            '404': "Standard404Error",
            '500': "FXStandard500Error",
        }

        return self.api_client.call_api(
            '/api/v1/client/{clientHashId}/customer/{customerHashId}/wallet/{walletHashId}/conversions', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def fetch_conversion(self, client_hash_id : Annotated[constr(strict=True, max_length=36, min_length=36), Field(..., description="Unique identifier of the client.")], customer_hash_id : Annotated[constr(strict=True, max_length=36, min_length=36), Field(..., description="Unique identifier of the customer.")], wallet_hash_id : Annotated[constr(strict=True, max_length=36, min_length=36), Field(..., description="Unique identifier of the wallet.")], conversion_id : StrictStr, x_request_id : Annotated[Optional[StrictStr], Field(description="Enter a unique UUID value.")] = None, **kwargs) -> ConversionCreationResponse:  # noqa: E501
        """Fetch Conversion by id  # noqa: E501

        This API will retrieve an existing conversion with the conversionId.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.fetch_conversion(client_hash_id, customer_hash_id, wallet_hash_id, conversion_id, x_request_id, async_req=True)
        >>> result = thread.get()

        :param client_hash_id: Unique identifier of the client. (required)
        :type client_hash_id: str
        :param customer_hash_id: Unique identifier of the customer. (required)
        :type customer_hash_id: str
        :param wallet_hash_id: Unique identifier of the wallet. (required)
        :type wallet_hash_id: str
        :param conversion_id: (required)
        :type conversion_id: str
        :param x_request_id: Enter a unique UUID value.
        :type x_request_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: ConversionCreationResponse
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the fetch_conversion_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.fetch_conversion_with_http_info(client_hash_id, customer_hash_id, wallet_hash_id, conversion_id, x_request_id, **kwargs)  # noqa: E501

    @validate_arguments
    def fetch_conversion_with_http_info(self, client_hash_id : Annotated[constr(strict=True, max_length=36, min_length=36), Field(..., description="Unique identifier of the client.")], customer_hash_id : Annotated[constr(strict=True, max_length=36, min_length=36), Field(..., description="Unique identifier of the customer.")], wallet_hash_id : Annotated[constr(strict=True, max_length=36, min_length=36), Field(..., description="Unique identifier of the wallet.")], conversion_id : StrictStr, x_request_id : Annotated[Optional[StrictStr], Field(description="Enter a unique UUID value.")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Fetch Conversion by id  # noqa: E501

        This API will retrieve an existing conversion with the conversionId.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.fetch_conversion_with_http_info(client_hash_id, customer_hash_id, wallet_hash_id, conversion_id, x_request_id, async_req=True)
        >>> result = thread.get()

        :param client_hash_id: Unique identifier of the client. (required)
        :type client_hash_id: str
        :param customer_hash_id: Unique identifier of the customer. (required)
        :type customer_hash_id: str
        :param wallet_hash_id: Unique identifier of the wallet. (required)
        :type wallet_hash_id: str
        :param conversion_id: (required)
        :type conversion_id: str
        :param x_request_id: Enter a unique UUID value.
        :type x_request_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(ConversionCreationResponse, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'client_hash_id',
            'customer_hash_id',
            'wallet_hash_id',
            'conversion_id',
            'x_request_id'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method fetch_conversion" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['client_hash_id']:
            _path_params['clientHashId'] = _params['client_hash_id']

        if _params['customer_hash_id']:
            _path_params['customerHashId'] = _params['customer_hash_id']

        if _params['wallet_hash_id']:
            _path_params['walletHashId'] = _params['wallet_hash_id']

        if _params['conversion_id']:
            _path_params['conversionId'] = _params['conversion_id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['x_request_id']:
            _header_params['x-request-id'] = _params['x_request_id']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['default']  # noqa: E501

        _response_types_map = {
            '200': "ConversionCreationResponse",
            '400': "FetchConversionErrorResponse",
            '401': "FXStandard401Error",
            '403': "FXStandard403Error",
            '404': "Standard404Error",
            '500': "FXStandard500Error",
        }

        return self.api_client.call_api(
            '/api/v1/client/{clientHashId}/customer/{customerHashId}/wallet/{walletHashId}/conversions/{conversionId}', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
