# coding: utf-8

"""
    NIUM Platform

    NIUM Platform

    Contact: experience@nium.com
    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, conlist
from nium.models.category_data import CategoryData

class AddCategoryResponseDTO(BaseModel):
    """
    AddCategoryResponseDTO
    """
    data: Optional[conlist(CategoryData)] = Field(None, description="This object contains the list of Category Constants")
    __properties = ["data"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AddCategoryResponseDTO:
        """Create an instance of AddCategoryResponseDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in data (list)
        _items = []
        if self.data:
            for _item in self.data:
                if _item:
                    _items.append(_item.to_dict())
            _dict['data'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AddCategoryResponseDTO:
        """Create an instance of AddCategoryResponseDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AddCategoryResponseDTO.parse_obj(obj)

        _obj = AddCategoryResponseDTO.parse_obj({
            "data": [CategoryData.from_dict(_item) for _item in obj.get("data")] if obj.get("data") is not None else None
        })
        return _obj


